/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ActivitiesQualMetrics type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActivitiesQualMetrics{}

// ActivitiesQualMetrics struct for ActivitiesQualMetrics
type ActivitiesQualMetrics struct {
	ReturningAmount *int32 `json:"returning_amount,omitempty"`
	RepeatAmount *int32 `json:"repeat_amount,omitempty"`
	ReferringAmount *int32 `json:"referring_amount,omitempty"`
	HookedAmount *int32 `json:"hooked_amount,omitempty"`
	AchievingAmount *int32 `json:"achieving_amount,omitempty"`
}

// NewActivitiesQualMetrics instantiates a new ActivitiesQualMetrics object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivitiesQualMetrics() *ActivitiesQualMetrics {
	this := ActivitiesQualMetrics{}
	return &this
}

// NewActivitiesQualMetricsWithDefaults instantiates a new ActivitiesQualMetrics object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivitiesQualMetricsWithDefaults() *ActivitiesQualMetrics {
	this := ActivitiesQualMetrics{}
	return &this
}

// GetReturningAmount returns the ReturningAmount field value if set, zero value otherwise.
func (o *ActivitiesQualMetrics) GetReturningAmount() int32 {
	if o == nil || IsNil(o.ReturningAmount) {
		var ret int32
		return ret
	}
	return *o.ReturningAmount
}

// GetReturningAmountOk returns a tuple with the ReturningAmount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesQualMetrics) GetReturningAmountOk() (*int32, bool) {
	if o == nil || IsNil(o.ReturningAmount) {
		return nil, false
	}
	return o.ReturningAmount, true
}

// HasReturningAmount returns a boolean if a field has been set.
func (o *ActivitiesQualMetrics) HasReturningAmount() bool {
	if o != nil && !IsNil(o.ReturningAmount) {
		return true
	}

	return false
}

// SetReturningAmount gets a reference to the given int32 and assigns it to the ReturningAmount field.
func (o *ActivitiesQualMetrics) SetReturningAmount(v int32) {
	o.ReturningAmount = &v
}

// GetRepeatAmount returns the RepeatAmount field value if set, zero value otherwise.
func (o *ActivitiesQualMetrics) GetRepeatAmount() int32 {
	if o == nil || IsNil(o.RepeatAmount) {
		var ret int32
		return ret
	}
	return *o.RepeatAmount
}

// GetRepeatAmountOk returns a tuple with the RepeatAmount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesQualMetrics) GetRepeatAmountOk() (*int32, bool) {
	if o == nil || IsNil(o.RepeatAmount) {
		return nil, false
	}
	return o.RepeatAmount, true
}

// HasRepeatAmount returns a boolean if a field has been set.
func (o *ActivitiesQualMetrics) HasRepeatAmount() bool {
	if o != nil && !IsNil(o.RepeatAmount) {
		return true
	}

	return false
}

// SetRepeatAmount gets a reference to the given int32 and assigns it to the RepeatAmount field.
func (o *ActivitiesQualMetrics) SetRepeatAmount(v int32) {
	o.RepeatAmount = &v
}

// GetReferringAmount returns the ReferringAmount field value if set, zero value otherwise.
func (o *ActivitiesQualMetrics) GetReferringAmount() int32 {
	if o == nil || IsNil(o.ReferringAmount) {
		var ret int32
		return ret
	}
	return *o.ReferringAmount
}

// GetReferringAmountOk returns a tuple with the ReferringAmount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesQualMetrics) GetReferringAmountOk() (*int32, bool) {
	if o == nil || IsNil(o.ReferringAmount) {
		return nil, false
	}
	return o.ReferringAmount, true
}

// HasReferringAmount returns a boolean if a field has been set.
func (o *ActivitiesQualMetrics) HasReferringAmount() bool {
	if o != nil && !IsNil(o.ReferringAmount) {
		return true
	}

	return false
}

// SetReferringAmount gets a reference to the given int32 and assigns it to the ReferringAmount field.
func (o *ActivitiesQualMetrics) SetReferringAmount(v int32) {
	o.ReferringAmount = &v
}

// GetHookedAmount returns the HookedAmount field value if set, zero value otherwise.
func (o *ActivitiesQualMetrics) GetHookedAmount() int32 {
	if o == nil || IsNil(o.HookedAmount) {
		var ret int32
		return ret
	}
	return *o.HookedAmount
}

// GetHookedAmountOk returns a tuple with the HookedAmount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesQualMetrics) GetHookedAmountOk() (*int32, bool) {
	if o == nil || IsNil(o.HookedAmount) {
		return nil, false
	}
	return o.HookedAmount, true
}

// HasHookedAmount returns a boolean if a field has been set.
func (o *ActivitiesQualMetrics) HasHookedAmount() bool {
	if o != nil && !IsNil(o.HookedAmount) {
		return true
	}

	return false
}

// SetHookedAmount gets a reference to the given int32 and assigns it to the HookedAmount field.
func (o *ActivitiesQualMetrics) SetHookedAmount(v int32) {
	o.HookedAmount = &v
}

// GetAchievingAmount returns the AchievingAmount field value if set, zero value otherwise.
func (o *ActivitiesQualMetrics) GetAchievingAmount() int32 {
	if o == nil || IsNil(o.AchievingAmount) {
		var ret int32
		return ret
	}
	return *o.AchievingAmount
}

// GetAchievingAmountOk returns a tuple with the AchievingAmount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesQualMetrics) GetAchievingAmountOk() (*int32, bool) {
	if o == nil || IsNil(o.AchievingAmount) {
		return nil, false
	}
	return o.AchievingAmount, true
}

// HasAchievingAmount returns a boolean if a field has been set.
func (o *ActivitiesQualMetrics) HasAchievingAmount() bool {
	if o != nil && !IsNil(o.AchievingAmount) {
		return true
	}

	return false
}

// SetAchievingAmount gets a reference to the given int32 and assigns it to the AchievingAmount field.
func (o *ActivitiesQualMetrics) SetAchievingAmount(v int32) {
	o.AchievingAmount = &v
}

func (o ActivitiesQualMetrics) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActivitiesQualMetrics) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReturningAmount) {
		toSerialize["returning_amount"] = o.ReturningAmount
	}
	if !IsNil(o.RepeatAmount) {
		toSerialize["repeat_amount"] = o.RepeatAmount
	}
	if !IsNil(o.ReferringAmount) {
		toSerialize["referring_amount"] = o.ReferringAmount
	}
	if !IsNil(o.HookedAmount) {
		toSerialize["hooked_amount"] = o.HookedAmount
	}
	if !IsNil(o.AchievingAmount) {
		toSerialize["achieving_amount"] = o.AchievingAmount
	}
	return toSerialize, nil
}

type NullableActivitiesQualMetrics struct {
	value *ActivitiesQualMetrics
	isSet bool
}

func (v NullableActivitiesQualMetrics) Get() *ActivitiesQualMetrics {
	return v.value
}

func (v *NullableActivitiesQualMetrics) Set(val *ActivitiesQualMetrics) {
	v.value = val
	v.isSet = true
}

func (v NullableActivitiesQualMetrics) IsSet() bool {
	return v.isSet
}

func (v *NullableActivitiesQualMetrics) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivitiesQualMetrics(val *ActivitiesQualMetrics) *NullableActivitiesQualMetrics {
	return &NullableActivitiesQualMetrics{value: val, isSet: true}
}

func (v NullableActivitiesQualMetrics) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivitiesQualMetrics) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


